#ifndef INCLUDES_H
#define INCLUDES_H

#include <stdint.h>
#include <stddef.h>
#include <stdarg.h>

// evil hack to avoid trap definitions
#define _STRUCTURE_PICTURES
#define __SPIC__(a, b, c, d)
#include <PalmOS.h>
#include <PceNativeCall.h>
#undef  _STRUCTURE_PICTURES
#undef  __SPIC__

#include "assert.h"
#include "stdlib.h"
#include "xmalloc.h"


// assorted types
typedef int32_t ssize_t;


// prototypes for gcc builtins
extern char *strcpy(char *dst, const char *src);
extern char *strncpy(char *dst, const char *src, size_t len);
extern size_t strlen(const char *s);
extern char *strchr(const char *s, int c);
extern char *strrchr(const char *s, int c);
extern char *strstr(const char *big, const char *little);
extern void *memcpy(void *dst, const void *src, size_t len);
extern void *memset(void *b, int c, size_t len);
extern int strncmp(const char *s1, const char *s2, size_t len);
extern void *memmove(void *dst, const void *src, size_t len);
extern char *strcat(char *s, const char *append);
extern char *strncat(char *s, const char *append, size_t count);
extern int memcmp(const void *b1, const void *b2, size_t len);


// misc definitions

#define RCSID(str) /* */

#ifndef MAX
# define MAX(a,b) (((a)>(b))?(a):(b))
# define MIN(a,b) (((a)<(b))?(a):(b))
#endif


// logging
static inline void noop() { }

#define fortuna_log noop
#define rand_log noop
#define vt100_log noop


// custom event types
#define usrNetEvent (sysEventFirstUserEvent+0)
#define usrDrawVT100Event (sysEventFirstUserEvent+1)
#define usrDrawCloseBoxEvent (sysEventFirstUserEvent+2)
#define usrSetScrollBarEvent (sysEventFirstUserEvent+3)

#pragma pack(2)
typedef struct {
    uint16_t eType;
    Boolean penDown;
    UInt8 tapCount;
    Int16 screenX;
    Int16 screenY;
    union {
        struct _GenericEventType generic;
        struct {
            void *frontend;
            int16_t total;
            int16_t start;
            int16_t page;
        } sbar;
    } data;
} SetScrollBarEventType;

#endif
